/*
 * Copyright 2009 Lari Natri <lari.natri@gmail.com>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package compid.application;

import compid.gui.DatasetCollectionComponent;
import net.aavalla.utils.jobpool.parameters.gui.ValueComponent;
import compid.report.DatasetCollection;
import compid.report.ReportModel;
import net.aavalla.utils.jobpool.parameters.FieldInstance;
import net.aavalla.utils.jobpool.parameters.FieldTypeHandler;

/**
 *
 * @author Lari Natri
 */
public class CompidFieldTypeHandler implements FieldTypeHandler {

    @Override
    public Class getAsSupportedType(final Class rawType) {
        Class testType = rawType;
        Class supportedType = null;
        while (supportedType==null && testType!=null && !testType.equals(Object.class)) {

            if (testType.equals(DatasetCollection.class)) {
                supportedType = DatasetCollection.class;
            }
            if (testType.equals(ReportModel.class)) {
                supportedType = ReportModel.class;
            }

            if (supportedType==null) {
                testType = testType.getSuperclass();
            }
        }
        return supportedType;
    }

    @Override
    public Object convertType(final Object value, final Class valueType, final Class returnType) {
        return value;
    }

    @Override
    public ValueComponent getValueComponentFor(Class supportedType, FieldInstance f, boolean allowEdit) {
            if (supportedType.equals(DatasetCollection.class)) {
                return new DatasetCollectionComponent(f, allowEdit);
            } else {
                return null;
            }

    }

}
